'use strict';

var _reactTransformHmr2 = require('react-transform-hmr');

var _reactTransformHmr3 = _interopRequireDefault(_reactTransformHmr2);

var _react = require('react');

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _helpersResizeDetectorStyles = require('../helpers/resizeDetectorStyles');

var _components = {
  _$ResizeDetector: {
    displayName: 'ResizeDetector'
  }
};

var _reactComponentWrapper = (0, _reactTransformHmr3['default'])({
  filename: 'src/components/ResizeDetector.js',
  components: _components,
  locals: [module],
  imports: [_react]
});

function _wrapComponent(uniqueId) {
  return function (ReactClass) {
    return _reactComponentWrapper(ReactClass, uniqueId);
  };
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var ResizeDetector = (function (_Component) {
  _inherits(ResizeDetector, _Component);

  function ResizeDetector(props) {
    _classCallCheck(this, _ResizeDetector);

    _get(Object.getPrototypeOf(_ResizeDetector.prototype), 'constructor', this).call(this);

    this.state = {
      expandChildHeight: 0,
      expandChildWidth: 0,
      expandScrollLeft: 0,
      expandScrollTop: 0,
      shrinkScrollTop: 0,
      shrinkScrollLeft: 0,
      lastWidth: 0,
      lastHeight: 0
    };

    this.reset = this.reset.bind(this);
    this.handleScroll = this.handleScroll.bind(this);
  }

  _createClass(ResizeDetector, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.props != nextProps;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.reset();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var expand = this.expand;
      var shrink = this.shrink;

      expand.scrollLeft = expand.scrollWidth;
      expand.scrollTop = expand.scrollHeight;

      shrink.scrollLeft = shrink.scrollWidth;
      shrink.scrollTop = shrink.scrollHeight;
    }
  }, {
    key: 'reset',
    value: function reset() {
      var expand = this.expand;
      var container = this.container;
      var props = this.props;

      this.setState({
        expandChildHeight: expand.offsetHeight + 10,
        expandChildWidth: expand.offsetWidth + 10,
        lastWidth: props.handleWidth && container.parentElement.offsetWidth,
        lastHeight: props.handleHeight && container.parentElement.offsetHeight
      });
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll(evt) {
      var container = this.container;
      var state = this.state;
      var props = this.props;

      if (props.handleWidth && container.parentElement.offsetWidth != state.lastWidth || props.handleHeight && container.parentElement.offsetHeight != state.lastHeight) {
        this.props.onResize();
      }

      this.reset();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this = this;

      var state = this.state;

      var expandStyle = _extends({}, _helpersResizeDetectorStyles.expandChildStyle, {
        width: state.expandChildWidth,
        height: state.expandChildHeight
      });

      return _react2['default'].createElement(
        'div',
        { style: _helpersResizeDetectorStyles.parentStyle, ref: function (ref) {
            _this.container = (0, _reactDom.findDOMNode)(ref);
          } },
        _react2['default'].createElement(
          'div',
          { style: _helpersResizeDetectorStyles.parentStyle, onScroll: this.handleScroll, ref: function (ref) {
              _this.expand = (0, _reactDom.findDOMNode)(ref);
            } },
          _react2['default'].createElement('div', { style: expandStyle })
        ),
        _react2['default'].createElement(
          'div',
          { style: _helpersResizeDetectorStyles.parentStyle, onScroll: this.handleScroll, ref: function (ref) {
              _this.shrink = (0, _reactDom.findDOMNode)(ref);
            } },
          _react2['default'].createElement('div', { style: _helpersResizeDetectorStyles.shrinkChildStyle })
        )
      );
    }
  }]);

  var _ResizeDetector = ResizeDetector;
  ResizeDetector = _wrapComponent('_$ResizeDetector')(ResizeDetector) || ResizeDetector;
  return ResizeDetector;
})(_react.Component);

exports['default'] = ResizeDetector;

ResizeDetector.propTypes = {
  handleWidth: _react.PropTypes.bool,
  handleHeight: _react.PropTypes.bool,
  onResize: _react.PropTypes.func.isRequired
};

ResizeDetector.defaultProps = {
  handleWidth: false,
  handleHeight: false,
  onResize: function onResize() {
    return console.error('ResizeDetector:onResize');
  }
};
module.exports = exports['default'];